// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Idcookie.pas' rev: 11.00

#ifndef IdcookieHPP
#define IdcookieHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Idglobal.hpp>	// Pascal unit
#include <Idexception.hpp>	// Pascal unit
#include <Idglobalprotocols.hpp>	// Pascal unit
#include <Iduri.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Idcookie
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TIdCookie;
class PASCALIMPLEMENTATION TIdCookie : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
protected:
	AnsiString FDomain;
	System::TDateTime FExpires;
	bool FHttpOnly;
	AnsiString FName;
	AnsiString FPath;
	bool FSecure;
	AnsiString FValue;
	System::TDateTime FCreatedAt;
	bool FHostOnly;
	System::TDateTime FLastAccessed;
	bool FPersistent;
	bool __fastcall GetIsExpired(void);
	virtual AnsiString __fastcall GetServerCookie();
	virtual AnsiString __fastcall GetClientCookie();
	__int64 __fastcall GetMaxAge(void);
	
public:
	__fastcall virtual TIdCookie(Classes::TCollection* ACollection);
	__fastcall virtual ~TIdCookie(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall IsAllowed(Iduri::TIdURI* AURI, bool SecureOnly);
	virtual bool __fastcall ParseClientCookie(const AnsiString ACookieText);
	virtual bool __fastcall ParseServerCookie(const AnsiString ACookieText, Iduri::TIdURI* AURI);
	__property AnsiString ClientCookie = {read=GetClientCookie};
	__property AnsiString CookieName = {read=FName, write=FName};
	__property AnsiString CookieText = {read=GetServerCookie};
	__property AnsiString Domain = {read=FDomain, write=FDomain};
	__property System::TDateTime Expires = {read=FExpires, write=FExpires};
	__property bool HttpOnly = {read=FHttpOnly, write=FHttpOnly, nodefault};
	__property AnsiString Path = {read=FPath, write=FPath};
	__property bool Secure = {read=FSecure, write=FSecure, nodefault};
	__property AnsiString ServerCookie = {read=GetServerCookie};
	__property AnsiString Value = {read=FValue, write=FValue};
	__property __int64 MaxAge = {read=GetMaxAge};
	__property System::TDateTime CreatedAt = {read=FCreatedAt, write=FCreatedAt};
	__property bool IsExpired = {read=GetIsExpired, nodefault};
	__property bool HostOnly = {read=FHostOnly, write=FHostOnly, nodefault};
	__property System::TDateTime LastAccessed = {read=FLastAccessed, write=FLastAccessed};
	__property bool Persistent = {read=FPersistent, write=FPersistent, nodefault};
};


typedef TMetaClass* TIdCookieClass;

class DELPHICLASS TIdCookieList;
class PASCALIMPLEMENTATION TIdCookieList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TIdCookie* operator[](int Index) { return Cookies[Index]; }
	
protected:
	TIdCookie* __fastcall GetCookie(int Index);
	void __fastcall SetCookie(int Index, TIdCookie* AValue);
	
public:
	int __fastcall IndexOfCookie(TIdCookie* ACookie);
	__property TIdCookie* Cookies[int Index] = {read=GetCookie, write=SetCookie/*, default*/};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TIdCookieList(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TIdCookieList(void) : Classes::TList() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TIdCookieAccess { caRead, caReadWrite };
#pragma option pop

class DELPHICLASS TIdCookies;
class PASCALIMPLEMENTATION TIdCookies : public Classes::TOwnedCollection 
{
	typedef Classes::TOwnedCollection inherited;
	
public:
	TIdCookie* operator[](int Index) { return Cookies[Index]; }
	
protected:
	TIdCookieList* FCookieList;
	Sysutils::TMultiReadExclusiveWriteSynchronizer* FRWLock;
	TIdCookie* __fastcall GetCookieByNameAndDomain(const AnsiString AName, const AnsiString ADomain);
	TIdCookie* __fastcall GetCookie(int Index);
	void __fastcall SetCookie(int Index, const TIdCookie* Value);
	
public:
	__fastcall TIdCookies(Classes::TPersistent* AOwner);
	__fastcall virtual ~TIdCookies(void);
	HIDESBASE TIdCookie* __fastcall Add(void);
	bool __fastcall AddCookie(TIdCookie* ACookie, Iduri::TIdURI* AURI, bool AReplaceOld = true);
	TIdCookie* __fastcall AddClientCookie(const AnsiString ACookie);
	void __fastcall AddClientCookies(const AnsiString ACookie)/* overload */;
	void __fastcall AddClientCookies(const Classes::TStrings* ACookies)/* overload */;
	TIdCookie* __fastcall AddServerCookie(const AnsiString ACookie, Iduri::TIdURI* AURI);
	void __fastcall AddServerCookies(const Classes::TStrings* ACookies, Iduri::TIdURI* AURI);
	void __fastcall AddCookies(TIdCookies* ASource);
	virtual void __fastcall Assign(Classes::TPersistent* ASource);
	HIDESBASE void __fastcall Clear(void);
	int __fastcall GetCookieIndex(const AnsiString AName, int FirstIndex = 0x0)/* overload */;
	int __fastcall GetCookieIndex(const AnsiString AName, const AnsiString ADomain, int FirstIndex = 0x0)/* overload */;
	TIdCookieList* __fastcall LockCookieList(TIdCookieAccess AAccessType);
	void __fastcall UnlockCookieList(TIdCookieAccess AAccessType);
	__property TIdCookie* Cookie[AnsiString AName][AnsiString ADomain] = {read=GetCookieByNameAndDomain};
	__property TIdCookie* Cookies[int Index] = {read=GetCookie, write=SetCookie/*, default*/};
};


class DELPHICLASS EIdCookieError;
class PASCALIMPLEMENTATION EIdCookieError : public Idexception::EIdException 
{
	typedef Idexception::EIdException inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdCookieError(const AnsiString AMsg)/* overload */ : Idexception::EIdException(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdCookieError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idexception::EIdException(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdCookieError(int Ident)/* overload */ : Idexception::EIdException(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdCookieError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idexception::EIdException(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdCookieError(const AnsiString Msg, int AHelpContext) : Idexception::EIdException(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdCookieError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idexception::EIdException(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdCookieError(int Ident, int AHelpContext)/* overload */ : Idexception::EIdException(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdCookieError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idexception::EIdException(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdCookieError(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE AnsiString __fastcall CanonicalizeHostName(const AnsiString AHost);
extern PACKAGE bool __fastcall IsDomainMatch(const AnsiString AUriHost, const AnsiString ACookieDomain);
extern PACKAGE bool __fastcall IsPathMatch(const AnsiString AUriPath, const AnsiString ACookiePath);

}	/* namespace Idcookie */
using namespace Idcookie;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Idcookie
