// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Idsslopenssl.pas' rev: 11.00

#ifndef IdsslopensslHPP
#define IdsslopensslHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Idbuffer.hpp>	// Pascal unit
#include <Idctypes.hpp>	// Pascal unit
#include <Idglobal.hpp>	// Pascal unit
#include <Idexception.hpp>	// Pascal unit
#include <Idstackconsts.hpp>	// Pascal unit
#include <Idsockethandle.hpp>	// Pascal unit
#include <Idsslopensslheaders.hpp>	// Pascal unit
#include <Idcomponent.hpp>	// Pascal unit
#include <Idiohandler.hpp>	// Pascal unit
#include <Idglobalprotocols.hpp>	// Pascal unit
#include <Idtcpserver.hpp>	// Pascal unit
#include <Idthread.hpp>	// Pascal unit
#include <Idtcpconnection.hpp>	// Pascal unit
#include <Idintercept.hpp>	// Pascal unit
#include <Idiohandlersocket.hpp>	// Pascal unit
#include <Idssl.hpp>	// Pascal unit
#include <Idsocks.hpp>	// Pascal unit
#include <Idscheduler.hpp>	// Pascal unit
#include <Idyarn.hpp>	// Pascal unit
#include <Idiohandlerstack.hpp>	// Pascal unit
#include <Idbasecomponent.hpp>	// Pascal unit
#include <Idserveriohandler.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Idsslopenssl
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIdSSLVersion { sslvSSLv2, sslvSSLv23, sslvSSLv3, sslvTLSv1, sslvTLSv1_1, sslvTLSv1_2 };
#pragma option pop

typedef Set<TIdSSLVersion, sslvSSLv2, sslvTLSv1_2>  TIdSSLVersions;

#pragma option push -b-
enum TIdSSLMode { sslmUnassigned, sslmClient, sslmServer, sslmBoth };
#pragma option pop

#pragma option push -b-
enum TIdSSLVerifyMode { sslvrfPeer, sslvrfFailIfNoPeerCert, sslvrfClientOnce };
#pragma option pop

typedef Set<TIdSSLVerifyMode, sslvrfPeer, sslvrfClientOnce>  TIdSSLVerifyModeSet;

#pragma option push -b-
enum TIdSSLCtxMode { sslCtxClient, sslCtxServer };
#pragma option pop

#pragma option push -b-
enum TIdSSLAction { sslRead, sslWrite };
#pragma option pop

#pragma pack(push,1)
struct TIdSSLULong
{
	
	union
	{
		struct 
		{
			unsigned C1;
			
		};
		struct 
		{
			int L1;
			
		};
		struct 
		{
			Word W1;
			Word W2;
			
		};
		struct 
		{
			Byte B1;
			Byte B2;
			Byte B3;
			Byte B4;
			
		};
		
	};
} ;
#pragma pack(pop)

#pragma pack(push,4)
struct TIdSSLEVP_MD
{
	
public:
	unsigned Length;
	char MD[64];
} ;
#pragma pack(pop)

#pragma pack(push,4)
struct TIdSSLByteArray
{
	
public:
	unsigned Length;
	Byte *Data;
} ;
#pragma pack(pop)

typedef void __fastcall (__closure *TCallbackEvent)(const AnsiString AMsg);

typedef void __fastcall (__closure *TCallbackExEvent)(System::TObject* ASender, const Idsslopensslheaders::PSSL AsslSocket, const int AWhere, const int Aret, const AnsiString AType, const AnsiString AMsg);

typedef void __fastcall (__closure *TPasswordEvent)(AnsiString &Password);

typedef void __fastcall (__closure *TPasswordEventEx)(System::TObject* ASender, AnsiString &VPassword, const bool AIsWrite);

class DELPHICLASS TIdX509;
typedef bool __fastcall (__closure *TVerifyPeerEvent)(TIdX509* Certificate, bool AOk, int ADepth, int AError);

class DELPHICLASS TIdSSLIOHandlerSocketOpenSSL;
typedef void __fastcall (__closure *TIOHandlerNotify)(TIdSSLIOHandlerSocketOpenSSL* ASender);

class DELPHICLASS TIdSSLOptions;
class PASCALIMPLEMENTATION TIdSSLOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
protected:
	AnsiString fsRootCertFile;
	AnsiString fsCertFile;
	AnsiString fsKeyFile;
	AnsiString fsDHParamsFile;
	TIdSSLVersion fMethod;
	TIdSSLVersions fSSLVersions;
	TIdSSLMode fMode;
	int fVerifyDepth;
	TIdSSLVerifyModeSet fVerifyMode;
	AnsiString fVerifyDirs;
	AnsiString fCipherList;
	virtual void __fastcall AssignTo(Classes::TPersistent* Destination);
	void __fastcall SetSSLVersions(const TIdSSLVersions AValue);
	void __fastcall SetMethod(const TIdSSLVersion AValue);
	
public:
	__fastcall TIdSSLOptions(void);
	
__published:
	__property AnsiString RootCertFile = {read=fsRootCertFile, write=fsRootCertFile};
	__property AnsiString CertFile = {read=fsCertFile, write=fsCertFile};
	__property AnsiString KeyFile = {read=fsKeyFile, write=fsKeyFile};
	__property AnsiString DHParamsFile = {read=fsDHParamsFile, write=fsDHParamsFile};
	__property TIdSSLVersion Method = {read=fMethod, write=SetMethod, default=3};
	__property TIdSSLVersions SSLVersions = {read=fSSLVersions, write=SetSSLVersions, default=8};
	__property TIdSSLMode Mode = {read=fMode, write=fMode, nodefault};
	__property TIdSSLVerifyModeSet VerifyMode = {read=fVerifyMode, write=fVerifyMode, nodefault};
	__property int VerifyDepth = {read=fVerifyDepth, write=fVerifyDepth, nodefault};
	__property AnsiString VerifyDirs = {read=fVerifyDirs, write=fVerifyDirs};
	__property AnsiString CipherList = {read=fCipherList, write=fCipherList};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIdSSLOptions(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIdSSLContext;
class PASCALIMPLEMENTATION TIdSSLContext : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TIdSSLVersion fMethod;
	TIdSSLVersions fSSLVersions;
	TIdSSLMode fMode;
	AnsiString fsRootCertFile;
	AnsiString fsCertFile;
	AnsiString fsKeyFile;
	AnsiString fsDHParamsFile;
	int fVerifyDepth;
	TIdSSLVerifyModeSet fVerifyMode;
	AnsiString fVerifyDirs;
	AnsiString fCipherList;
	Idsslopensslheaders::SSL_CTX *fContext;
	bool fStatusInfoOn;
	bool fVerifyOn;
	int fSessionId;
	TIdSSLCtxMode fCtxMode;
	void __fastcall DestroyContext(void);
	Idsslopensslheaders::PSSL_METHOD __fastcall SetSSLMethod(void);
	void __fastcall SetVerifyMode(TIdSSLVerifyModeSet Mode, bool CheckRoutine);
	TIdSSLVerifyModeSet __fastcall GetVerifyMode(void);
	void __fastcall InitContext(TIdSSLCtxMode CtxMode);
	
public:
	System::TObject* Parent;
	__fastcall TIdSSLContext(void);
	__fastcall virtual ~TIdSSLContext(void);
	TIdSSLContext* __fastcall Clone(void);
	bool __fastcall LoadRootCert(void);
	bool __fastcall LoadCert(void);
	bool __fastcall LoadKey(void);
	bool __fastcall LoadDHParams(void);
	__property bool StatusInfoOn = {read=fStatusInfoOn, write=fStatusInfoOn, nodefault};
	__property bool VerifyOn = {read=fVerifyOn, write=fVerifyOn, nodefault};
	__property TIdSSLVersions SSLVersions = {read=fSSLVersions, write=fSSLVersions, nodefault};
	__property TIdSSLVersion Method = {read=fMethod, write=fMethod, nodefault};
	__property TIdSSLMode Mode = {read=fMode, write=fMode, nodefault};
	__property AnsiString RootCertFile = {read=fsRootCertFile, write=fsRootCertFile};
	__property AnsiString CertFile = {read=fsCertFile, write=fsCertFile};
	__property AnsiString CipherList = {read=fCipherList, write=fCipherList};
	__property AnsiString KeyFile = {read=fsKeyFile, write=fsKeyFile};
	__property AnsiString DHParamsFile = {read=fsDHParamsFile, write=fsDHParamsFile};
	__property AnsiString VerifyDirs = {read=fVerifyDirs, write=fVerifyDirs};
	__property TIdSSLVerifyModeSet VerifyMode = {read=fVerifyMode, write=fVerifyMode, nodefault};
	__property int VerifyDepth = {read=fVerifyDepth, write=fVerifyDepth, nodefault};
};


class DELPHICLASS TIdSSLSocket;
class DELPHICLASS TIdSSLCipher;
class PASCALIMPLEMENTATION TIdSSLCipher : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TIdSSLSocket* FSSLSocket;
	AnsiString __fastcall GetDescription();
	AnsiString __fastcall GetName();
	int __fastcall GetBits(void);
	AnsiString __fastcall GetVersion();
	
public:
	__fastcall TIdSSLCipher(TIdSSLSocket* AOwner);
	__fastcall virtual ~TIdSSLCipher(void);
	__property AnsiString Description = {read=GetDescription};
	__property AnsiString Name = {read=GetName};
	__property int Bits = {read=GetBits, nodefault};
	__property AnsiString Version = {read=GetVersion};
};


class PASCALIMPLEMENTATION TIdSSLSocket : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::TObject* fParent;
	TIdX509* fPeerCert;
	Idsslopensslheaders::SSL *fSSL;
	TIdSSLCipher* fSSLCipher;
	TIdSSLContext* fSSLContext;
	AnsiString fHostName;
	TIdX509* __fastcall GetPeerCert(void);
	int __fastcall GetSSLError(int retCode);
	TIdSSLCipher* __fastcall GetSSLCipher(void);
	
public:
	__fastcall TIdSSLSocket(System::TObject* Parent);
	__fastcall virtual ~TIdSSLSocket(void);
	void __fastcall Accept(const unsigned pHandle);
	void __fastcall Connect(const unsigned pHandle);
	int __fastcall Send(const Idglobal::TIdBytes ABuffer, int AOffset, int ALength);
	int __fastcall Recv(Idglobal::TIdBytes &ABuffer);
	TIdSSLByteArray __fastcall GetSessionID();
	AnsiString __fastcall GetSessionIDAsString();
	void __fastcall SetCipherList(AnsiString CipherList);
	__property TIdX509* PeerCert = {read=GetPeerCert};
	__property TIdSSLCipher* Cipher = {read=GetSSLCipher};
	__property AnsiString HostName = {read=fHostName};
};


__interface IIdSSLOpenSSLCallbackHelper;
typedef System::DelphiInterface<IIdSSLOpenSSLCallbackHelper> _di_IIdSSLOpenSSLCallbackHelper;
__interface  INTERFACE_UUID("{583F1209-10BA-4E06-8810-155FAEC415FE}") IIdSSLOpenSSLCallbackHelper  : public IInterface 
{
	
public:
	virtual AnsiString __fastcall GetPassword(const bool AIsWrite) = 0 ;
	virtual void __fastcall StatusInfo(const Idsslopensslheaders::PSSL ASSL, int AWhere, int ARet, const AnsiString AStatusStr) = 0 ;
	virtual bool __fastcall VerifyPeer(TIdX509* ACertificate, bool AOk, int ADepth, int AError) = 0 ;
	virtual TIdSSLIOHandlerSocketOpenSSL* __fastcall GetIOHandlerSelf(void) = 0 ;
};

class PASCALIMPLEMENTATION TIdSSLIOHandlerSocketOpenSSL : public Idssl::TIdSSLIOHandlerSocketBase 
{
	typedef Idssl::TIdSSLIOHandlerSocketBase inherited;
	
protected:
	TIdSSLContext* fSSLContext;
	TIdSSLOptions* fxSSLOptions;
	TIdSSLSocket* fSSLSocket;
	TCallbackEvent fOnStatusInfo;
	TCallbackExEvent FOnStatusInfoEx;
	TPasswordEvent fOnGetPassword;
	TPasswordEventEx fOnGetPasswordEx;
	TVerifyPeerEvent fOnVerifyPeer;
	bool fSSLLayerClosed;
	TIOHandlerNotify fOnBeforeConnect;
	virtual void __fastcall SetPassThrough(const bool Value);
	virtual void __fastcall DoBeforeConnect(TIdSSLIOHandlerSocketOpenSSL* ASender);
	virtual void __fastcall DoStatusInfo(const AnsiString AMsg);
	void __fastcall DoStatusInfoEx(const Idsslopensslheaders::PSSL AsslSocket, const int AWhere, const int Aret, const AnsiString AWhereStr, const AnsiString ARetStr);
	virtual void __fastcall DoGetPassword(AnsiString &Password);
	virtual void __fastcall DoGetPasswordEx(AnsiString &VPassword, const bool AIsWrite);
	virtual bool __fastcall DoVerifyPeer(TIdX509* Certificate, bool AOk, int ADepth, int AError);
	virtual int __fastcall RecvEnc(Idglobal::TIdBytes &VBuffer);
	virtual int __fastcall SendEnc(const Idglobal::TIdBytes ABuffer, const int AOffset, const int ALength);
	void __fastcall Init(void);
	virtual void __fastcall OpenEncodedConnection(void);
	virtual void __fastcall InitComponent(void);
	virtual void __fastcall ConnectClient(void);
	virtual int __fastcall CheckForError(int ALastResult);
	virtual void __fastcall RaiseError(int AError);
	AnsiString __fastcall GetPassword(const bool AIsWrite);
	void __fastcall StatusInfo(const Idsslopensslheaders::PSSL ASslSocket, int AWhere, int ARet, const AnsiString AStatusStr);
	bool __fastcall VerifyPeer(TIdX509* ACertificate, bool AOk, int ADepth, int AError);
	TIdSSLIOHandlerSocketOpenSSL* __fastcall GetIOHandlerSelf(void);
	
public:
	__fastcall virtual ~TIdSSLIOHandlerSocketOpenSSL(void);
	virtual Idssl::TIdSSLIOHandlerSocketBase* __fastcall Clone(void);
	virtual void __fastcall StartSSL(void);
	virtual void __fastcall AfterAccept(void);
	virtual void __fastcall Close(void);
	virtual void __fastcall Open(void);
	virtual bool __fastcall Readable(int AMSec = 0xffffffff);
	__property TIdSSLSocket* SSLSocket = {read=fSSLSocket, write=fSSLSocket};
	__property TIOHandlerNotify OnBeforeConnect = {read=fOnBeforeConnect, write=fOnBeforeConnect};
	__property TIdSSLContext* SSLContext = {read=fSSLContext, write=fSSLContext};
	
__published:
	__property TIdSSLOptions* SSLOptions = {read=fxSSLOptions, write=fxSSLOptions};
	__property TCallbackEvent OnStatusInfo = {read=fOnStatusInfo, write=fOnStatusInfo};
	__property TCallbackExEvent OnStatusInfoEx = {read=FOnStatusInfoEx, write=FOnStatusInfoEx};
	__property TPasswordEvent OnGetPassword = {read=fOnGetPassword, write=fOnGetPassword};
	__property TPasswordEventEx OnGetPasswordEx = {read=fOnGetPasswordEx, write=fOnGetPasswordEx};
	__property TVerifyPeerEvent OnVerifyPeer = {read=fOnVerifyPeer, write=fOnVerifyPeer};
public:
	#pragma option push -w-inl
	/* TIdIOHandler.Create */ inline __fastcall TIdSSLIOHandlerSocketOpenSSL(Classes::TComponent* AOwner)/* overload */ : Idssl::TIdSSLIOHandlerSocketBase(AOwner) { }
	#pragma option pop
	
private:
	void *__IIdSSLOpenSSLCallbackHelper;	/* Idsslopenssl::IIdSSLOpenSSLCallbackHelper */
	
public:
	#if defined(MANAGED_INTERFACE_OPERATORS)
	operator _di_IIdSSLOpenSSLCallbackHelper()
	{
		_di_IIdSSLOpenSSLCallbackHelper intf;
		GetInterface(intf);
		return intf;
	}
	#else
	operator IIdSSLOpenSSLCallbackHelper*(void) { return (IIdSSLOpenSSLCallbackHelper*)&__IIdSSLOpenSSLCallbackHelper; }
	#endif
	
};


class DELPHICLASS TIdServerIOHandlerSSLOpenSSL;
class PASCALIMPLEMENTATION TIdServerIOHandlerSSLOpenSSL : public Idssl::TIdServerIOHandlerSSLBase 
{
	typedef Idssl::TIdServerIOHandlerSSLBase inherited;
	
protected:
	TIdSSLOptions* fxSSLOptions;
	TIdSSLContext* fSSLContext;
	TCallbackEvent fOnStatusInfo;
	TCallbackExEvent FOnStatusInfoEx;
	TPasswordEvent fOnGetPassword;
	TPasswordEventEx fOnGetPasswordEx;
	TVerifyPeerEvent fOnVerifyPeer;
	virtual void __fastcall DoStatusInfo(const AnsiString AMsg);
	void __fastcall DoStatusInfoEx(const Idsslopensslheaders::PSSL AsslSocket, const int AWhere, const int Aret, const AnsiString AWhereStr, const AnsiString ARetStr);
	virtual void __fastcall DoGetPassword(AnsiString &Password);
	virtual void __fastcall DoGetPasswordEx(AnsiString &VPassword, const bool AIsWrite);
	virtual bool __fastcall DoVerifyPeer(TIdX509* Certificate, bool AOk, int ADepth, int AError);
	virtual void __fastcall InitComponent(void);
	AnsiString __fastcall GetPassword(const bool AIsWrite);
	void __fastcall StatusInfo(const Idsslopensslheaders::PSSL ASslSocket, int AWhere, int ARet, const AnsiString AStatusStr);
	bool __fastcall VerifyPeer(TIdX509* ACertificate, bool AOk, int ADepth, int AError);
	TIdSSLIOHandlerSocketOpenSSL* __fastcall GetIOHandlerSelf(void);
	
public:
	virtual void __fastcall Init(void);
	virtual void __fastcall Shutdown(void);
	virtual Idiohandler::TIdIOHandler* __fastcall Accept(Idsockethandle::TIdSocketHandle* ASocket, Idthread::TIdThread* AListenerThread, Idyarn::TIdYarn* AYarn);
	__fastcall virtual ~TIdServerIOHandlerSSLOpenSSL(void);
	virtual Idssl::TIdSSLIOHandlerSocketBase* __fastcall MakeClientIOHandler(void)/* overload */;
	virtual Idssl::TIdSSLIOHandlerSocketBase* __fastcall MakeFTPSvrPort(void);
	virtual Idssl::TIdSSLIOHandlerSocketBase* __fastcall MakeFTPSvrPasv(void);
	__property TIdSSLContext* SSLContext = {read=fSSLContext};
	
__published:
	__property TIdSSLOptions* SSLOptions = {read=fxSSLOptions, write=fxSSLOptions};
	__property TCallbackEvent OnStatusInfo = {read=fOnStatusInfo, write=fOnStatusInfo};
	__property TCallbackExEvent OnStatusInfoEx = {read=FOnStatusInfoEx, write=FOnStatusInfoEx};
	__property TPasswordEvent OnGetPassword = {read=fOnGetPassword, write=fOnGetPassword};
	__property TPasswordEventEx OnGetPasswordEx = {read=fOnGetPasswordEx, write=fOnGetPasswordEx};
	__property TVerifyPeerEvent OnVerifyPeer = {read=fOnVerifyPeer, write=fOnVerifyPeer};
public:
	#pragma option push -w-inl
	/* TIdBaseComponent.Create */ inline __fastcall TIdServerIOHandlerSSLOpenSSL(Classes::TComponent* AOwner)/* overload */ : Idssl::TIdServerIOHandlerSSLBase(AOwner) { }
	#pragma option pop
	
	
/* Hoisted overloads: */
	
public:
	inline Idiohandler::TIdIOHandler* __fastcall  MakeClientIOHandler(Idyarn::TIdYarn* ATheThread){ return TIdServerIOHandlerSSLBase::MakeClientIOHandler(ATheThread); }
	
private:
	void *__IIdSSLOpenSSLCallbackHelper;	/* Idsslopenssl::IIdSSLOpenSSLCallbackHelper */
	
public:
	#if defined(MANAGED_INTERFACE_OPERATORS)
	operator _di_IIdSSLOpenSSLCallbackHelper()
	{
		_di_IIdSSLOpenSSLCallbackHelper intf;
		GetInterface(intf);
		return intf;
	}
	#else
	operator IIdSSLOpenSSLCallbackHelper*(void) { return (IIdSSLOpenSSLCallbackHelper*)&__IIdSSLOpenSSLCallbackHelper; }
	#endif
	
};


class DELPHICLASS TIdX509Name;
class PASCALIMPLEMENTATION TIdX509Name : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	Idsslopensslheaders::X509_NAME *fX509Name;
	AnsiString __fastcall CertInOneLine();
	TIdSSLULong __fastcall GetHash(void);
	AnsiString __fastcall GetHashAsString();
	
public:
	__fastcall TIdX509Name(Idsslopensslheaders::PX509_NAME aX509Name);
	__property TIdSSLULong Hash = {read=GetHash};
	__property AnsiString HashAsString = {read=GetHashAsString};
	__property AnsiString OneLine = {read=CertInOneLine};
	__property Idsslopensslheaders::PX509_NAME CertificateName = {read=fX509Name};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TIdX509Name(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIdX509Info;
class PASCALIMPLEMENTATION TIdX509Info : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	Idsslopensslheaders::X509 *FX509;
	
public:
	__fastcall TIdX509Info(Idsslopensslheaders::PX509 aX509);
	__property Idsslopensslheaders::PX509 Certificate = {read=FX509};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TIdX509Info(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIdX509Fingerprints;
class PASCALIMPLEMENTATION TIdX509Fingerprints : public TIdX509Info 
{
	typedef TIdX509Info inherited;
	
protected:
	TIdSSLEVP_MD __fastcall GetMD5();
	AnsiString __fastcall GetMD5AsString();
	TIdSSLEVP_MD __fastcall GetSHA1();
	AnsiString __fastcall GetSHA1AsString();
	TIdSSLEVP_MD __fastcall GetSHA224();
	AnsiString __fastcall GetSHA224AsString();
	TIdSSLEVP_MD __fastcall GetSHA256();
	AnsiString __fastcall GetSHA256AsString();
	TIdSSLEVP_MD __fastcall GetSHA384();
	AnsiString __fastcall GetSHA384AsString();
	TIdSSLEVP_MD __fastcall GetSHA512();
	AnsiString __fastcall GetSHA512AsString();
	
public:
	__property TIdSSLEVP_MD MD5 = {read=GetMD5};
	__property AnsiString MD5AsString = {read=GetMD5AsString};
	__property TIdSSLEVP_MD SHA1 = {read=GetSHA1};
	__property AnsiString SHA1AsString = {read=GetSHA1AsString};
	__property TIdSSLEVP_MD SHA224 = {read=GetSHA224};
	__property AnsiString SHA224AsString = {read=GetSHA224AsString};
	__property TIdSSLEVP_MD SHA256 = {read=GetSHA256};
	__property AnsiString SHA256AsString = {read=GetSHA256AsString};
	__property TIdSSLEVP_MD SHA384 = {read=GetSHA384};
	__property AnsiString SHA384AsString = {read=GetSHA384AsString};
	__property TIdSSLEVP_MD SHA512 = {read=GetSHA512};
	__property AnsiString SHA512AsString = {read=GetSHA512AsString};
public:
	#pragma option push -w-inl
	/* TIdX509Info.Create */ inline __fastcall TIdX509Fingerprints(Idsslopensslheaders::PX509 aX509) : TIdX509Info(aX509) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TIdX509Fingerprints(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIdX509SigInfo;
class PASCALIMPLEMENTATION TIdX509SigInfo : public TIdX509Info 
{
	typedef TIdX509Info inherited;
	
protected:
	AnsiString __fastcall GetSignature();
	int __fastcall GetSigType(void);
	AnsiString __fastcall GetSigTypeAsString();
	
public:
	__property AnsiString Signature = {read=GetSignature};
	__property int SigType = {read=GetSigType, nodefault};
	__property AnsiString SigTypeAsString = {read=GetSigTypeAsString};
public:
	#pragma option push -w-inl
	/* TIdX509Info.Create */ inline __fastcall TIdX509SigInfo(Idsslopensslheaders::PX509 aX509) : TIdX509Info(aX509) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TIdX509SigInfo(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIdX509 : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TIdX509Fingerprints* FFingerprints;
	TIdX509SigInfo* FSigInfo;
	bool FCanFreeX509;
	Idsslopensslheaders::X509 *FX509;
	TIdX509Name* FSubject;
	TIdX509Name* FIssuer;
	Classes::TStrings* FDisplayInfo;
	TIdX509Name* __fastcall RSubject(void);
	TIdX509Name* __fastcall RIssuer(void);
	System::TDateTime __fastcall RnotBefore(void);
	System::TDateTime __fastcall RnotAfter(void);
	TIdSSLEVP_MD __fastcall RFingerprint();
	AnsiString __fastcall RFingerprintAsString();
	AnsiString __fastcall GetSerialNumber();
	int __fastcall GetVersion(void);
	Classes::TStrings* __fastcall GetDisplayInfo(void);
	
public:
	__fastcall virtual TIdX509(Idsslopensslheaders::PX509 aX509, bool aCanFreeX509);
	__fastcall virtual ~TIdX509(void);
	__property int Version = {read=GetVersion, nodefault};
	__property TIdX509SigInfo* SigInfo = {read=FSigInfo};
	__property TIdX509Fingerprints* Fingerprints = {read=FFingerprints};
	__property TIdSSLEVP_MD Fingerprint = {read=RFingerprint};
	__property AnsiString FingerprintAsString = {read=RFingerprintAsString};
	__property TIdX509Name* Subject = {read=RSubject};
	__property TIdX509Name* Issuer = {read=RIssuer};
	__property System::TDateTime notBefore = {read=RnotBefore};
	__property System::TDateTime notAfter = {read=RnotAfter};
	__property AnsiString SerialNumber = {read=GetSerialNumber};
	__property Classes::TStrings* DisplayInfo = {read=GetDisplayInfo};
	__property Idsslopensslheaders::PX509 Certificate = {read=FX509};
};


class DELPHICLASS EIdOSSLCouldNotLoadSSLLibrary;
class PASCALIMPLEMENTATION EIdOSSLCouldNotLoadSSLLibrary : public Idsslopensslheaders::EIdOpenSSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLCouldNotLoadSSLLibrary(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLCouldNotLoadSSLLibrary(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLCouldNotLoadSSLLibrary(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLModeNotSet;
class PASCALIMPLEMENTATION EIdOSSLModeNotSet : public Idsslopensslheaders::EIdOpenSSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLModeNotSet(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLModeNotSet(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLModeNotSet(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLModeNotSet(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLModeNotSet(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLModeNotSet(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLModeNotSet(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLModeNotSet(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLModeNotSet(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLGetMethodError;
class PASCALIMPLEMENTATION EIdOSSLGetMethodError : public Idsslopensslheaders::EIdOpenSSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLGetMethodError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLGetMethodError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLGetMethodError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLGetMethodError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLGetMethodError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLGetMethodError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLGetMethodError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLGetMethodError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLGetMethodError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLCreatingSessionError;
class PASCALIMPLEMENTATION EIdOSSLCreatingSessionError : public Idsslopensslheaders::EIdOpenSSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLCreatingSessionError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLCreatingSessionError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLCreatingSessionError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLCreatingSessionError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLCreatingSessionError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLCreatingSessionError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLCreatingSessionError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLCreatingSessionError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLCreatingSessionError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLCreatingContextError;
class PASCALIMPLEMENTATION EIdOSSLCreatingContextError : public Idsslopensslheaders::EIdOpenSSLAPICryptoError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPICryptoError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLCreatingContextError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLCreatingContextError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLCreatingContextError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLCreatingContextError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLCreatingContextError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLCreatingContextError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLCreatingContextError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLCreatingContextError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLCreatingContextError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLLoadingRootCertError;
class PASCALIMPLEMENTATION EIdOSSLLoadingRootCertError : public Idsslopensslheaders::EIdOpenSSLAPICryptoError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPICryptoError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLLoadingRootCertError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLLoadingRootCertError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLLoadingRootCertError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLLoadingRootCertError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLLoadingRootCertError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLLoadingRootCertError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLLoadingRootCertError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLLoadingRootCertError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLLoadingRootCertError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLLoadingCertError;
class PASCALIMPLEMENTATION EIdOSSLLoadingCertError : public Idsslopensslheaders::EIdOpenSSLAPICryptoError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPICryptoError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLLoadingCertError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLLoadingCertError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLLoadingCertError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLLoadingCertError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLLoadingCertError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLLoadingCertError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLLoadingCertError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLLoadingCertError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLLoadingCertError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLLoadingKeyError;
class PASCALIMPLEMENTATION EIdOSSLLoadingKeyError : public Idsslopensslheaders::EIdOpenSSLAPICryptoError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPICryptoError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLLoadingKeyError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLLoadingKeyError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLLoadingKeyError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLLoadingKeyError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLLoadingKeyError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLLoadingKeyError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLLoadingKeyError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLLoadingKeyError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLLoadingKeyError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLLoadingDHParamsError;
class PASCALIMPLEMENTATION EIdOSSLLoadingDHParamsError : public Idsslopensslheaders::EIdOpenSSLAPICryptoError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPICryptoError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLLoadingDHParamsError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLLoadingDHParamsError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLLoadingDHParamsError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLLoadingDHParamsError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLLoadingDHParamsError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLLoadingDHParamsError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLLoadingDHParamsError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLLoadingDHParamsError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPICryptoError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLLoadingDHParamsError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLSettingCipherError;
class PASCALIMPLEMENTATION EIdOSSLSettingCipherError : public Idsslopensslheaders::EIdOpenSSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLSettingCipherError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLSettingCipherError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLSettingCipherError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLSettingCipherError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLSettingCipherError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLSettingCipherError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLSettingCipherError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLSettingCipherError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLSettingCipherError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLFDSetError;
class PASCALIMPLEMENTATION EIdOSSLFDSetError : public Idsslopensslheaders::EIdOpenSSLAPISSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPISSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLFDSetError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLFDSetError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLFDSetError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLFDSetError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLFDSetError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLFDSetError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLFDSetError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLFDSetError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLFDSetError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLDataBindingError;
class PASCALIMPLEMENTATION EIdOSSLDataBindingError : public Idsslopensslheaders::EIdOpenSSLAPISSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPISSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLDataBindingError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLDataBindingError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLDataBindingError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLDataBindingError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLDataBindingError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLDataBindingError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLDataBindingError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLDataBindingError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLDataBindingError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLAcceptError;
class PASCALIMPLEMENTATION EIdOSSLAcceptError : public Idsslopensslheaders::EIdOpenSSLAPISSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPISSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLAcceptError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLAcceptError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLAcceptError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLAcceptError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLAcceptError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLAcceptError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLAcceptError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLAcceptError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLAcceptError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLConnectError;
class PASCALIMPLEMENTATION EIdOSSLConnectError : public Idsslopensslheaders::EIdOpenSSLAPISSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPISSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLConnectError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLConnectError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLConnectError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLConnectError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLConnectError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLConnectError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLConnectError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLConnectError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLConnectError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdOSSLSettingTLSHostNameError;
class PASCALIMPLEMENTATION EIdOSSLSettingTLSHostNameError : public Idsslopensslheaders::EIdOpenSSLAPISSLError 
{
	typedef Idsslopensslheaders::EIdOpenSSLAPISSLError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdOSSLSettingTLSHostNameError(const AnsiString AMsg)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdOSSLSettingTLSHostNameError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdOSSLSettingTLSHostNameError(int Ident)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdOSSLSettingTLSHostNameError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdOSSLSettingTLSHostNameError(const AnsiString Msg, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdOSSLSettingTLSHostNameError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idsslopensslheaders::EIdOpenSSLAPISSLError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdOSSLSettingTLSHostNameError(int Ident, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdOSSLSettingTLSHostNameError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idsslopensslheaders::EIdOpenSSLAPISSLError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdOSSLSettingTLSHostNameError(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const TIdSSLVersion DEF_SSLVERSION = (TIdSSLVersion)(3);
#define DEF_SSLVERSIONS (Set<TIdSSLVersion, sslvSSLv2, sslvTLSv1_2> () << sslvTLSv1 )
static const Shortint P12_FILETYPE = 0x3;
static const Byte MAX_SSL_PASSWORD_LENGTH = 0x80;
extern PACKAGE bool __fastcall LoadOpenSSLLibrary(void);
extern PACKAGE void __fastcall UnLoadOpenSSLLibrary(void);
extern PACKAGE AnsiString __fastcall OpenSSLVersion();

}	/* namespace Idsslopenssl */
using namespace Idsslopenssl;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Idsslopenssl
