/*
*  global.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef globalH
#define globalH
#include <dir.h>
#include "utility.h"
//---------------------------------------------------------------------------

//const AnsiString NewMessage = "new message";
//const int ComposeEditorFont = 0;
//const int ComposeDialogFont = 1;
//const int ComposeWindowFont = 2;

//const TColor DefNoteColor = 11270389;
//const int DefNoteHeight = 365;
//const int DefNoteWidth = 375;
//const bool DefNoteWordWrap = true;
//AnsiString __fastcall DefNoteOpts();

//const int OptsDefMessageWrap = 68;
const AnsiString OptsDefQuoteMarks = "> ";
const AnsiString OptsDefDialogFont = "Tahoma,10,r,0";
const AnsiString OptsDefWindowFont = "Tahoma,10,r,0";
const AnsiString OptsDefEditorFont = "Courier New,10,r,0";
const bool OptsDefFewerHeaders = true;
const int OptsMaxSMTPLogLines = 500;
const int RichEditIndent = 4;  // left margin of page
//const AnsiString DecryptVerifying = " Decrypting... ";

const UINT WM_SHOWSTATUS           = WM_USER + 101;
const UINT WM_FLASHDECRYPT 		   = WM_USER + 102;
const UINT WM_SAVEPROFILE		   = WM_USER + 103;
const UINT WM_SAVEMESSAGE		   = WM_USER + 104;
const UINT WM_INICHANGE			   = WM_USER + 105;
const UINT WM_SETSUBJECT		   = WM_USER + 106;
const UINT WM_SETMESSAGEREAD       = WM_USER + 107;
const UINT WM_SETMESSAGE           = WM_USER + 108;
const UINT WM_DELMESSAGE		   = WM_USER + 109;
const UINT WM_UPDATECOMPLETE	   = WM_USER + 110;
//const UINT WM_LOADPREVIEW    	   = WM_USER + 111;
const UINT WM_MARKMESSAGEREAD      = WM_USER + 112;
const UINT WM_ACCOUNTCHANGE        = WM_USER + 114;
const UINT WM_SHOWPROGRESS         = WM_USER + 115;
const UINT WM_PROGRESSERROR		   = WM_USER + 116;
const UINT WM_NEWMESSAGEKEY		   = WM_USER + 117;

const UINT WM_LOGDISPLAY           = WM_USER + 120;
const UINT WM_NNTPTIMEOUTTIMER     = WM_USER + 121;
const UINT WM_MESSAGEBOX           = WM_USER + 123;
const UINT WM_NNTPCANCEL		   = WM_USER + 125;
const UINT WM_SAVEDATABASE		   = WM_USER + 128;
const UINT WM_DELNNTPTHREAD        = WM_USER + 130;
const UINT WM_REPLYMESSAGE		   = WM_USER + 132;

const UINT WM_FEWERHEADERS         = WM_USER + 140;

const WORD CLEARLOG                = 1;
const WORD TIMERSTOP               = 0;
const WORD TIMERSTART			   = 1;
const WORD TIMERTIMEOUT			   = 2;

const UINT WM_TRAYICONMESSAGE      = WM_USER + 1997; // message for notifying tray actions
const UINT WM_TRAYICONSHOW         = WM_USER + 1998; // to restore from systray from second instance of app
const UINT WM_TRAYICON_ID          = 9;              // id define - needed for all tray icon messages
extern UINT WM_TASKBARCREATED;
extern UINT WM_QSAMESSAGE;
extern UINT WM_QSLMESSAGE;
extern UINT WM_QS2MESSAGE;
const WORD BRINGTOFRONT   = 1;     // wparam for WM_QSAMESSAGE
const WORD CLIPBOARDREPLY = 3;     // wparam for WM_QSLMESSAGE, WM_QS2MESSAGE
const WORD CLIPBOARDREPLY_NT = 4;  // same
const WORD COMPOSENEWMESSAGE = 5;  // wparam for WM_QSLMESSAGE

const WORD QSCOPYDATA_NT  = 998;
const WORD QSCOPYDATA     = 999;

bool __fastcall HasQSL();
AnsiString __fastcall AppDir();
AnsiString __fastcall AppIni();
AnsiString __fastcall AppChm();
AnsiString __fastcall AppChmWB();
AnsiString __fastcall AppDataDir();
AnsiString __fastcall AppDB();
AnsiString __fastcall AppDBTmp();
AnsiString __fastcall AppOldDB();
AnsiString __fastcall AppLicense();
AnsiString __fastcall AppDefsIni();
AnsiString __fastcall AppServersIni();
void __fastcall GetNextWindowXY(TForm *Window);
bool __fastcall SetApplicationDataDirectory();

const AnsiString QSLKnownProblemsURL = "https://www.quicksilvermail.net/qslite/qslknown.html";
const AnsiString QSLUpdatePageURL = "https://www.quicksilvermail.net/qslite";
const AnsiString MIXAllPingersURLs =
   "https://www.quicksilvermail.net/remailers/allpingers.txt,"
   "http://www.drsnoid.cotse.net/allpingers.txt,"
   "http://www.noreply.org/allpingers/allpingers.txt";
const AnsiString QSDefaultsURL = "https://www.quicksilvermail.net/remailers/defaults.txt";
const AnsiString QSDefaultsFILE = "defaults.txt";

extern TList *windowlist;
extern UINT WM_TASKBARCREATED;
extern UINT WM_HSMESSAGE;
extern AnsiString passphrase;
//---------------------------------------------------------------------------
#endif
