/*
*  locatedlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "locatedlgs.h"
#include "qsaver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLocateDlg *LocateDlg;
const AnsiString locmsg =
"I see you're installing QSA as a stand-alone application. That is to say, QSL "
"is not already in the installation directory. When installing stand-alone, its best NOT "
"to put it in the window's 'program files' directory. However, if you do, the QSA data files "
"will be kept in the user's application data directory, under \\quicksilver\\qsl.\n\n"
"If you decide to change your directory, just copy the files to that location.";
const AnsiString locmsg1 =
"Hey! Thanks for downloading QSAam! This program allows Windows users to locate, "
"download and decrypt incoming nym mail from the newsgroup alt.anonymous.messages. This "
"program doesn't setup or create nyms. It specifically gathers the mail for existing nyms."
"";
//---------------------------------------------------------------------------

bool __fastcall IsInstallDirectoryOK(TForm* Owner)
{
   TLocateDlg *locdlg = new TLocateDlg(Owner);
   locdlg->ShowModal();
   bool ok = locdlg->ModalResult == mrOk;
   delete locdlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TLocateDlg::TLocateDlg(TComponent* Owner)
	: TForm(Owner)
{
   Caption = QuickSilverVersion();
   RichEdit1->Lines->Text = locmsg;
}
//---------------------------------------------------------------------------

void __fastcall TLocateDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrCancel)
   {
	  CanClose = false;
	  MessageBeep(0);
	  return;
   }
}
//---------------------------------------------------------------------------
