/*
*  msgwins.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef msgwinsH
#define msgwinsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "global.h"
//---------------------------------------------------------------------------
void __fastcall ViewMessage(TForm* Owner, const AnsiString &Key, TStrings *Msg);
//void __fastcall FormatMessage(TStrings *msg);

class TMsgWin : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TSpeedButton *OkBtn;
	TSpeedButton *DecryptBtn;
	TSpeedButton *DeleteBtn;
	TSpeedButton *CopyBtn;
	TBevel *Bevel2;
	TBevel *Bevel3;
	TBevel *Bevel7;
	TRichEdit *Viewer;
	TSpeedButton *CopyMsgBtn;
	TStatusBar *StatusBar;
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *Exit1;
	TMenuItem *Edit1;
	TMenuItem *Copy1;
	TMenuItem *Selectall1;
	TMenuItem *ools1;
	TMenuItem *Decrypt1;
	TMenuItem *Copytoclipboard1;
	TMenuItem *N1;
	TTimer *Timer1;
	TTimer *Timer2;
	TPopupMenu *PopupMenu1;
	TMenuItem *Copymessagetoclipnoard1;
	TMenuItem *N2;
	TMenuItem *Copy2;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *Decrypt2;
	TCheckBox *FewerHeaders;
	TTimer *DecryptTimer;
	void __fastcall FormResize(TObject *Sender);
	void __fastcall ViewerSelectionChange(TObject *Sender);
	void __fastcall CopyBtnClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall CopyMsgBtnClick(TObject *Sender);
	void __fastcall Exit1Click(TObject *Sender);
	void __fastcall Selectall1Click(TObject *Sender);
	void __fastcall Decrypt1Click(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall DeleteBtnClick(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
	void __fastcall Edit1Click(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	void __fastcall FewerHeadersClick(TObject *Sender);
	void __fastcall DecryptTimerTimer(TObject *Sender);
private:	// User declarations
        void __fastcall CreateParams( TCreateParams &Params );
public:		// User declarations
    TStrings *objmsg;
	AnsiString orgwin, msgkey, subnohdr, cap;
	__fastcall virtual TMsgWin(TComponent* Owner);
	__fastcall virtual TMsgWin(TComponent* Owner, const AnsiString &Key, TStrings *Msg);
	__fastcall virtual~TMsgWin();
    bool __fastcall NeedsDecryptVerify(TStrings *msg);
	void __fastcall MarkMessageRead(AnsiString &msgkey);
	AnsiString __fastcall GetSubject(TStrings *msg);
	AnsiString __fastcall GetFrom(TStrings *msg);
	int __fastcall OwnerPerform(UINT msg, WPARAM wParam, LPARAM lParam);
	void __fastcall ShowStatus(const AnsiString &msg);
	AnsiString __fastcall GetNymAndTypeHeader(const AnsiString &MsgKey);
	// message functions
	void virtual __fastcall WMFlashDecrypt(TMessage& Msg);
	void virtual __fastcall WMReplyMessage(TMessage& Msg);
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_FLASHDECRYPT, TMessage, WMFlashDecrypt)
	MESSAGE_HANDLER(WM_REPLYMESSAGE, TMessage, WMReplyMessage);
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMsgWin *MsgWin;
//---------------------------------------------------------------------------
#endif
