/*
*  nntphostdlgs.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef nntphostdlgsH
#define nntphostdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

bool __fastcall AddNNTPHost(TForm *Owner, TStrings *host, TStrings *existing);
bool __fastcall EditNNTPHost(TForm *Owner, TStrings *host, TStrings *existing);
//bool __fastcall ManageSingleSMTPServer(TForm *Owner, bool &reloadmessage);

class TNNTPHostDlg : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label3;
	TEdit *NNTPServer;
        TLabel *Label4;
	TEdit *NNTPPort;
	TCheckBox *NNTPAuth;
        TLabel *Label2;
	TEdit *NNTPUserID;
        TLabel *Label5;
	TEdit *NNTPPassword;
	TEdit *NNTPKey;
        TLabel *Label1;
        TBevel *Bevel1;
        TButton *OkBtn;
        TButton *CancelBtn;
        TButton *ProxyBtn;
        TCheckBox *HideBox;
	TComboBox *NNTPTls;
	TLabel *Label7;
	TEdit *NNTPLastArticle;
	TLabel *Label6;
	TButton *HelpBtn;
		void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
		void __fastcall NNTPAuthClick(TObject *Sender);
		void __fastcall NNTPServerExit(TObject *Sender);
		void __fastcall ProxyBtnClick(TObject *Sender);
		void __fastcall HideBoxClick(TObject *Sender);
	void __fastcall NNTPPortExit(TObject *Sender);
        void __fastcall NNTPPortChange(TObject *Sender);
        void __fastcall NNTPServerChange(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
		bool expertmode;
		AnsiString orgname;
        TStrings *existing, *hostdata;
		__fastcall virtual TNNTPHostDlg(TComponent* Owner);
        __fastcall virtual TNNTPHostDlg(TComponent* Owner, TStrings *hostdata,
           TStrings *existing);
        bool __fastcall Modified();
};
//---------------------------------------------------------------------------
//extern PACKAGE TSMTPHostDlg *SMTPHostDlg;
//---------------------------------------------------------------------------
#endif
