//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "nntpthrds.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(&UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall NNTPThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall NNTPThread::NNTPThread(bool CreateSuspended)
	: TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------

__fastcall NNTPThread::NNTPThread(HANDLE Owner, bool CreateSuspended)
	: TThread(CreateSuspended)
{
   owner = Owner;
   SSLContext = new TSslContext(NULL);
   NNTP = new TSslNntpCli(NULL);
   NNTP->SslContext = SSLContext;
   NNTP->OnDisplay = NNTPDisplay;
   NNTP->OnMessageBegin = NNTPMessageBegin;
   NNTP->OnMessageLine = NNTPMessageLine;
   NNTP->OnMessageEnd = NNTPMessageEnd;
   NNTP->OnRcvdData = NNTPRcvdData;
   NNTP->OnRequestDone = NNTPRequestDone;
   NNTP->OnSendData = NNTPSendData;
   NNTP->OnSessionClosed = NNTPSessionClosed;
   NNTP->OnSessionConnected = NNTPSessionConnected;
   NNTP->OnXHdrBegin = NNTPXHdrBegin;
   NNTP->OnXHdrEnd = NNTPXHdrEnd;
   NNTP->OnXHdrLine = NNTPXHdrLine;
   transcript = new TStringList();
   proxy = new TStringList();
   subjects = new TStringList();
   profile = new TStringList();
   TIniFile *ini = new TIniFile(AppIni());
   newsgroup = ini->ReadString("settings", "newsgroup", "alt.anonymous.messages");
   nntpproxy = ini->ReadString("settings", "nntpproxy", "none");
   maxloglines = ini->ReadInteger("settings", "loglines", 1000);
   SSLContext->SslCipherList = ini->ReadString(SSLCipherSuites, NntpSSLciphersuite, NntpSSLCipherSuite);
   delete ini;
   data = new TStringList();
   msgman = new TMsgManager(data);
   ShowProgress(0,0,"");
}
//---------------------------------------------------------------------------

void __fastcall NNTPThread::Execute()
{
   StartRetrieve();
}
//---------------------------------------------------------------------------
