//---------------------------------------------------------------------------

#ifndef nntpthrdsH
#define nntpthrdsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------

class NNTPThread : public TThread
{
private:
	void __fastcall NNTPDisplay(TObject *Sender, Pointer MsgBuf, int MsgLen);
	void __fastcall NNTPMessageBegin(TObject *Sender);
	void __fastcall NNTPMessageLine(TObject *Sender);
	void __fastcall NNTPMessageEnd(TObject *Sender);
	void __fastcall NNTPRcvdData(TObject *Sender);
	void __fastcall NNTPRequestDone(TObject *Sender, TNntpRequest RqType, WORD ErrCode);
	void __fastcall NNTPSendData(TObject *Sender);
	void __fastcall NNTPSessionClosed(TObject *Sender, WORD ErrCode);
	void __fastcall NNTPSessionConnected(TObject *Sender, WORD ErrCode);
	void __fastcall NNTPXHdrBegin(TObject *Sender);
	void __fastcall NNTPXHdrEnd(TObject *Sender);
	void __fastcall NNTPXHdrLine(TObject *Sender);
	bool __fastcall GetTheMail();
	UINT __fastcall OwnerPerform(UINT msg, WPARAM wparam, LPARAM lparam);
	void __fastcall ShowProgress(const double current, const double total, const AnsiString &article);
	void __fastcall ShowStatus(const AnsiString &msg);
	bool __fastcall SetupProxy();
	int  __fastcall PercentComplete(double next);
	void __fastcall Display(const AnsiString &msg);
	bool __fastcall SubjectMatch(const AnsiString &msgsubject);
	bool __fastcall SubjectMatch(TMsgManager *msg);
	void __fastcall SaveLog();
	void __fastcall RetrieveComplete();
	void __fastcall StartRetrieve();
protected:
	void __fastcall Execute();
public:
	TSslNntpCli *NNTP;
	TSslContext *SSLContext;
	TMsgManager *msgman;
	double next, totalarticles;
	AnsiString nntpproxy, newsgroup, account;
	int maxloglines, mails, curmsg, lasterror;
	bool subsonly, catchup, working, canceled, connecting, nada, aborted, timedout;
	TStringList *profile, *transcript, *proxy, *subjects, *data;
	HANDLE owner;
	__fastcall virtual NNTPThread(bool CreateSuspended);
	__fastcall virtual NNTPThread(HANDLE Owner, bool CreateSuspended)
	__fastcall virtual~NNTPThread();
};
//---------------------------------------------------------------------------
#endif
