//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "nymoptsdlgs.h"
#include "utility.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymOptionsDlg *NymOptionsDlg;
//---------------------------------------------------------------------------

bool __fastcall GetGhioNymOptions(TForm *Owner, const AnsiString &Nym, AnsiString &anonto,
   AnsiString &options)
{
   TNymOptionsDlg *optsdlg = new TNymOptionsDlg(Owner);
   optsdlg->Caption = "Create GHIO nym --> " + Nym;
   optsdlg->AnonTo->Text = anonto;
   optsdlg->SetNymOptions(options);
   optsdlg->ShowModal();
   bool ok = optsdlg->ModalResult == mrOk;
   if (ok)
   {
	  anonto = optsdlg->AnonTo->Text;
	  options = optsdlg->GetNymOptions();
   }
   delete optsdlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNymOptionsDlg::TNymOptionsDlg(TComponent* Owner)
	: TForm(Owner)
{
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(AnonTo->Font, ini->ReadString("settings", "windowfont",
	  OptsDefWindowFont));
   delete ini;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TNymOptionsDlg::GetNymOptions()
{
   AnsiString options;
   options += (AnsiString(acksend->Checked ? " +":" -")+"acksend");
   options += (AnsiString(cryptrecv->Checked ? " +":" -")+"cryptrecv");
   options += (AnsiString(nobcc->Checked ? " +":" -")+"nobcc");
   options += (AnsiString(signsend->Checked ? " +":" -")+"signsend");
   options += (AnsiString(fingerkey->Checked ? " +":" -")+"fingerkey");
   return options;
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall TNymOptionsDlg::GetNymOptions()
{
   AnsiString options;
   options += (AnsiString(acksend->Checked ? " +acksend":""));
   options += (AnsiString(cryptrecv->Checked ? " +cryptrecv":""));
   options += (AnsiString(nobcc->Checked ? " +nobcc":""));
   options += (AnsiString(signsend->Checked ? " +signsend":""));
   options += (AnsiString(fingerkey->Checked ? " +fingerkey":""));
   return options;
}*/
//---------------------------------------------------------------------------

void __fastcall TNymOptionsDlg::SetNymOptions(const AnsiString &options)
{
   acksend->Checked = options.Pos("+acksend") > 0;
   cryptrecv->Checked = options.Pos("+cryptrecv") > 0;
   nobcc->Checked = options.Pos("+nobcc") > 0;
   signsend->Checked = options.Pos("+signsend") > 0;
   fingerkey->Checked = options.Pos("+fingerkey") > 0;
}
//---------------------------------------------------------------------------

void __fastcall TNymOptionsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (AnonTo->Text.IsEmpty())
   {
	  MsgBox(this, "Anon-To is a required field!   ", MT_INFO, MB_OK);
	  CanClose = false;
   }
}
//---------------------------------------------------------------------------

