//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "nymsrvmandlgs.h"
#include "nymserverdlgs.h"
#include "utility.h"
#include "qsadbs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymSrvManDlg *NymSrvManDlg;
//---------------------------------------------------------------------------

bool __fastcall ManageNymservers(TForm *Owner)
{
   TNymSrvManDlg *mandlg = new TNymSrvManDlg(Owner);
   mandlg->ShowModal();
   bool ok = mandlg->modified;
   delete mandlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNymSrvManDlg::TNymSrvManDlg(TComponent* Owner)
	: TForm(Owner)
{
   servers = new TStringList();
   DB->LoadNymservers(servers);
   ListView->Items->Count = servers->Count;
}
//---------------------------------------------------------------------------

__fastcall TNymSrvManDlg::~TNymSrvManDlg()
{
   delete servers;
}
//---------------------------------------------------------------------------

void __fastcall TNymSrvManDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified)
	  DB->SaveNymservers(servers);
}
//---------------------------------------------------------------------------

void __fastcall TNymSrvManDlg::ListViewClick(TObject *Sender)
{
   EditBtn->Enabled = ListView->Selected;
   DeleteBtn->Enabled = EditBtn->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TNymSrvManDlg::ListViewData(TObject *Sender, TListItem *Item)
{
   int idx = Item->Index;
   TStringList *server = new TStringList();
   AnsiString type, domain = servers->Names[idx];
   server->CommaText = servers->Values[domain];
   type = server->Values["type"];
   Item->Caption = domain;
   if (Item->SubItems->Count)
	  Item->SubItems->Strings[0] = type;
   else
	  Item->SubItems->Add(type);
   delete server;
}
//---------------------------------------------------------------------------

void __fastcall TNymSrvManDlg::NewBtnClick(TObject *Sender)
{
   TStringList *server = new TStringList();
   if (NewNymserver(this, server, servers))
   {
	  servers->Values[server->Values["server"]] = server->CommaText;
	  ListView->Items->Count = servers->Count;
	  modified = true;
   }
   delete server;
}
//---------------------------------------------------------------------------

void __fastcall TNymSrvManDlg::EditBtnClick(TObject *Sender)
{
   TStringList *server = new TStringList();
   AnsiString domain = servers->Names[ListView->ItemIndex];
   server->CommaText = servers->Values[domain];
   if (EditNymserver(this, server))
   {
	  servers->Values[domain] = server->CommaText;
	  ListView->Invalidate();
	  modified = true;
   }
   delete server;
}
//---------------------------------------------------------------------------

void __fastcall TNymSrvManDlg::DeleteBtnClick(TObject *Sender)
{
   assert(ListView->Selected);
   if (MsgBox(this, "Delete the current nymserver?  ",
	  MT_CONFIRM, MB_OKCANCEL) == IDOK)
   {
	  servers->Delete(ListView->Selected->Index);
	  ListView->Items->Count = servers->Count;
	  modified = true;
   }
}
//---------------------------------------------------------------------------
