/*
*  subjectsmandlgs.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef subjectsmandlgsH
#define subjectsmandlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
bool __fastcall ManageSubjectLines(TForm *Owner);

class TSubjectsManDlg : public TForm
{
__published:	// IDE-managed Components
	TButton *EditBtn;
	TButton *DeleteBtn;
	TButton *NewBtn;
	TButton *Done;
	TListView *ListView;
	TPopupMenu *PopupMenu;
	TMenuItem *Add1;
	TMenuItem *Edit1;
	TMenuItem *Delete1;
	TMenuItem *N1;
	TMenuItem *Resizedialog1;
	TMenuItem *Locksize1;
	TLabel *Label1;
	TButton *HelpBtn;
	void __fastcall PopupMenuPopup(TObject *Sender);
	void __fastcall Resizedialog1Click(TObject *Sender);
	void __fastcall Locksize1Click(TObject *Sender);
	void __fastcall ListViewClick(TObject *Sender);
	void __fastcall AddItemClick(TObject *Sender);
	void __fastcall DeleteItemClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall EditItemClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	bool modified;
	TStringList *subjects;
	AnsiString orgwin, newsgroup;
	__fastcall TSubjectsManDlg(TComponent* Owner);
	__fastcall virtual ~TSubjectsManDlg();
	bool __fastcall SubjectExists(const AnsiString &Subject);
};
//---------------------------------------------------------------------------
extern PACKAGE TSubjectsManDlg *SubjectsManDlg;
//---------------------------------------------------------------------------
#endif
